/* =============================================================================
 *
 *  Description: This is a C++ implementation for Thread ADI_TTCP_IdleThreadType
 *
 * -----------------------------------------------------------------------------
 *  Comments:
 *
 * ===========================================================================*/

#include "ADI_TTCP_IdleThreadType.h"
#include <new>

extern "C" void TTCP_IdleFunction(void); // added JW

/******************************************************************************
 *  ADI_TTCP_IdleThreadType Run Function (ADI_TTCP_IdleThreadType's main{})
 */
 
void
ADI_TTCP_IdleThreadType::Run()
{
    // TODO - Put the thread's "main" Initialization HERE

    while (1)
    {
        // TODO - Put the thread's "main" body HERE
		TTCP_IdleFunction(); // added JW
        // Use a "break" instruction to exit the "while (1)" loop
    }

    // TODO - Put the thread's exit from "main" HERE
	// A thread is automatically Destroyed when it exits its run function
}

/******************************************************************************
 *  ADI_TTCP_IdleThreadType Error Handler
 */
 
int
ADI_TTCP_IdleThreadType::ErrorHandler()
{
    /* TODO - Put this thread's error handling code HERE */

    /* The default ErrorHandler (called below)  raises
     * a kernel panic and stops the system */
    return (VDK::Thread::ErrorHandler());
}

/******************************************************************************
 *  ADI_TTCP_IdleThreadType Constructor
 */
 
ADI_TTCP_IdleThreadType::ADI_TTCP_IdleThreadType(VDK::Thread::ThreadCreationBlock &tcb)
    : VDK::Thread(tcb)
{
    /* This routine does NOT run in new thread's context.  Any non-static thread
     *   initialization should be performed at the beginning of "Run()."
     */

    // TODO - Put code to be executed when this thread has just been created HERE

}

/******************************************************************************
 *  ADI_TTCP_IdleThreadType Destructor
 */
 
ADI_TTCP_IdleThreadType::~ADI_TTCP_IdleThreadType()
{
    /* This routine does NOT run in the thread's context.  Any VDK API calls
     *   should be performed at the end of "Run()."
     */

    // TODO - Put code to be executed just before this thread is destroyed HERE

}

/******************************************************************************
 *  ADI_TTCP_IdleThreadType Externally Accessible, Pre-Constructor Create Function
 */
 
VDK::Thread*
ADI_TTCP_IdleThreadType::Create(VDK::Thread::ThreadCreationBlock &tcb)
{
    /* This routine does NOT run in new thread's context.  Any non-static thread
     *   initialization should be performed at the beginning of "Run()."
     */

    	return new (tcb) ADI_TTCP_IdleThreadType(tcb);
}

/* ========================================================================== */
